ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.22 by root, Wed Dec 15 00:17:48 2010 UTC vs.
Revision 1.40 by root, Sun May 1 07:56:26 2011 UTC

7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10# perl build variables 10# perl build variables
11MAKE=make 11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc 13PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 17
18ARCH="$(uname -m)" 18ARCH="$(uname -m)"
19 19
20case "$ARCH" in 20case "$ARCH" in
29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 37
37# some configuration options for modules 38# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
41 44
42# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
43# required by mkbundle 46# required by mkbundle
44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
45 48
46# which extra modules you might want to install 49# which extra modules you might want to install
47EXTRA_MODULES="" 50EXTRA_MODULES=""
48 51
49# overridable functions 52# overridable functions
50preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
51postconfigure() { : ; } 55postconfigure() { : ; }
52postbuild() { : ; } 56postbuild() { : ; }
53postinstall() { : ; } 57postinstall() { : ; }
54 58
55# now source user config, if any 59# now source user config, if any
62fi 66fi
63 67
64############################################################################# 68#############################################################################
65# support 69# support
66 70
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69 72
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
71export LC_ALL=C # just to be on the safe side 75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
72 80
73# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
74VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
75$VERSION=0.912 83$VERSION="1.21"
76 84
77BZ2=bz2 85BZ2=bz2
78BZIP2=bzip2 86BZIP2=bzip2
79 87
80fatal() { 88fatal() {
126 134
127clean() { 135clean() {
128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 136 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
129} 137}
130 138
139realclean() {
140 rm -f "$PERL_PREFIX/staticstamp.postinstall"
141 rm -f "$PERL_PREFIX/staticstamp.install"
142 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
143}
144
131fetch() { 145fetch() {
132 rcd "$STATICPERL" 146 rcd "$STATICPERL"
133 147
134 mkdir -p src 148 mkdir -p src
135 rcd src 149 rcd src
145perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
146trying $URL 160trying $URL
147EOF 161EOF
148 162
149 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 163 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
164 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
150 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 165 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
151 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
152 || fatal "$URL: unable to download" 166 || fatal "$URL: unable to download"
153 rm -f perl-$PERL_VERSION.tar.$BZ2 167 rm -f perl-$PERL_VERSION.tar.$BZ2
154 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 168 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
155 fi 169 fi
156 170
158unpacking perl 172unpacking perl
159EOF 173EOF
160 174
161 mkdir -p unpack 175 mkdir -p unpack
162 rm -rf unpack/perl-$PERL_VERSION 176 rm -rf unpack/perl-$PERL_VERSION
163 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 177 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
164 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 178 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
165 chmod -R u+w unpack/perl-$PERL_VERSION 179 chmod -R u+w unpack/perl-$PERL_VERSION
166 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 180 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
167 rmdir -p unpack 181 rmdir -p unpack
168 fi 182 fi
169} 183}
214 228
215 rm -f "$PERL_PREFIX/staticstamp.install" 229 rm -f "$PERL_PREFIX/staticstamp.install"
216 230
217 "$MAKE" distclean >/dev/null 2>&1 231 "$MAKE" distclean >/dev/null 2>&1
218 232
233 sedreplace '/^#define SITELIB/d' config_h.SH
234
219 # I hate them 235 # I hate them for this
220 grep -q -- -fstack-protector Configure && \ 236 grep -q -- -fstack-protector Configure && \
221 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 237 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
222 238
223 preconfigure 239 # what did that bloke think
240 grep -q -- usedl=.define hints/darwin.sh && \
241 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
242
243 preconfigure || fatal "preconfigure hook failed"
224 244
225# trace configure \ 245# trace configure \
226 sh Configure -Duselargefiles \ 246 sh Configure -Duselargefiles \
227 -Uuse64bitint \ 247 -Uuse64bitint \
228 -Dusemymalloc=n \ 248 -Dusemymalloc=n \
230 -Uusethreads \ 250 -Uusethreads \
231 -Uuseithreads \ 251 -Uuseithreads \
232 -Uusemultiplicity \ 252 -Uusemultiplicity \
233 -Uusesfio \ 253 -Uusesfio \
234 -Uuseshrplib \ 254 -Uuseshrplib \
255 -Uinstallusrbinperl \
235 -A ccflags=" $PERL_CCFLAGS" \ 256 -A ccflags=" $PERL_CCFLAGS" \
236 -Dcc="$PERL_CC" \ 257 -Dcc="$PERL_CC" \
237 -Doptimize="$PERL_OPTIMIZE" \ 258 -Doptimize="$PERL_OPTIMIZE" \
238 -Dldflags="$PERL_LDFLAGS" \ 259 -Dldflags="$PERL_LDFLAGS" \
239 -Dlibs="$PERL_LIBS" \ 260 -Dlibs="$PERL_LIBS" \
242 -Dprivlib="$PERL_PREFIX/lib" \ 263 -Dprivlib="$PERL_PREFIX/lib" \
243 -Darchlib="$PERL_PREFIX/lib" \ 264 -Darchlib="$PERL_PREFIX/lib" \
244 -Uusevendorprefix \ 265 -Uusevendorprefix \
245 -Dsitelib="$PERL_PREFIX/lib" \ 266 -Dsitelib="$PERL_PREFIX/lib" \
246 -Dsitearch="$PERL_PREFIX/lib" \ 267 -Dsitearch="$PERL_PREFIX/lib" \
247 -Usitelibexp \
248 -Uman1dir \ 268 -Uman1dir \
249 -Uman3dir \ 269 -Uman3dir \
250 -Usiteman1dir \ 270 -Usiteman1dir \
251 -Usiteman3dir \ 271 -Usiteman3dir \
252 -Dpager=/usr/bin/less \ 272 -Dpager=/usr/bin/less \
260 sedreplace ' 280 sedreplace '
261 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 281 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
262 s/ *-fno-stack-protector */ /g 282 s/ *-fno-stack-protector */ /g
263 ' config.sh 283 ' config.sh
264 284
285 patchconfig || fatal "patchconfig hook failed"
286
265 sh Configure -S || fatal "Configure -S failed" 287 sh Configure -S || fatal "Configure -S failed"
266 288
267 postconfigure || fatal "postconfigure hook failed" 289 postconfigure || fatal "postconfigure hook failed"
268 290
269 touch staticstamp.configure 291 touch staticstamp.configure
292}
293
294write_shellscript() {
295 {
296 echo "#!/bin/sh"
297 echo "STATICPERL=\"$STATICPERL\""
298 echo "PERL_PREFIX=\"$PERL_PREFIX\""
299 echo "MAKE=\"$MAKE\""
300 cat
301 } >"$PERL_PREFIX/bin/$1"
302 chmod 755 "$PERL_PREFIX/bin/$1"
270} 303}
271 304
272build() { 305build() {
273 configure 306 configure
274 307
295EOF 328EOF
296 329
297 ln -sf "perl/bin/" "$STATICPERL/bin" 330 ln -sf "perl/bin/" "$STATICPERL/bin"
298 ln -sf "perl/lib/" "$STATICPERL/lib" 331 ln -sf "perl/lib/" "$STATICPERL/lib"
299 332
333 mkdir "$STATICPERL/patched"
334
300 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 335 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
301 rm -rf "$PERL_PREFIX" # by this rm -rf 336 rm -rf "$PERL_PREFIX" # by this rm -rf
302 337
303 "$MAKE" install || fatal "make install: error while installing" 338 "$MAKE" install || fatal "make install: error while installing"
304 339
305 rcd "$PERL_PREFIX" 340 rcd "$PERL_PREFIX"
306 341
307 # create a "make install" replacement for CPAN 342 # create a "make install" replacement for CPAN
308 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 343 write_shellscript SP-make-install-make <<'EOF'
309"$MAKE" || exit 344#CAT make-install-make.sh
310
311if find blib/arch/auto -type f | grep -q -v .exists; then
312 echo Probably an XS module, rebuilding perl
313 if "$MAKE" perl; then
314 mv perl "$PERL_PREFIX"/bin/perl~ \
315 && rm -f "$PERL_PREFIX"/bin/perl \
316 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
317 "$MAKE" -f Makefile.aperl map_clean
318 else
319 "$MAKE" -f Makefile.aperl map_clean
320 exit 1
321 fi
322fi
323
324"$MAKE" install UNINST=1
325EOF 345EOF
326 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
327 346
347 # create a "patch modules" helper
348 write_shellscript SP-patch-postinstall <<'EOF'
349#CAT patch-postinstall.sh
350EOF
351
352 "$PERL_PREFIX/bin/SP-patch-postinstall"
353
328 # trick CPAN into avoiding ~/.cpan completely 354 # help to trick CPAN into avoiding ~/.cpan completely
329 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 355 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
330 356
357 # we call cpan with -MCPAN::MyConfig in this script, which
358 # is strictly unnecssary as we have to patch CPAN anyway,
359 # so consider it "for good measure".
331 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 360 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
332 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 361 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
333 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 362 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
334 CPAN::Shell->o (conf => q<init>); 363 CPAN::Shell->o (conf => q<init>);
335 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 364 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
336 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 365 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
337 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 366 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
338 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 367 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
339 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 368 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
340 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 369 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
341 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 370 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
342 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 371 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
372 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
343 CPAN::Shell->o (conf => q<commit>); 373 CPAN::Shell->o (conf => q<commit>);
344 ' || fatal "error while initialising CPAN" 374 ' || fatal "error while initialising CPAN"
345 375
346 touch "$PERL_PREFIX/staticstamp.install" 376 touch "$PERL_PREFIX/staticstamp.install"
347 fi 377 fi
367installing modules from CPAN 397installing modules from CPAN
368$@ 398$@
369EOF 399EOF
370 400
371 for mod in "$@"; do 401 for mod in "$@"; do
372 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 402 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
373 || fatal "$mod: unable to install from CPAN" 403 || fatal "$mod: unable to install from CPAN"
374 done 404 done
375 rm -rf "$STATICPERL/build" 405 rm -rf "$STATICPERL/build"
376} 406}
377 407
393 rcd $mod 423 rcd $mod
394 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1 424 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
395 "$MAKE" distclean >/dev/null 2>&1 425 "$MAKE" distclean >/dev/null 2>&1
396 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 426 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
397 "$MAKE" || fatal "$mod: error building module" 427 "$MAKE" || fatal "$mod: error building module"
398 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 428 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
399 "$MAKE" distclean >/dev/null 2>&1 429 "$MAKE" distclean >/dev/null 2>&1
400 exit 0 430 exit 0
401 ) || exit $? 431 ) || exit $?
402 done 432 done
403} 433}
435#CAT mkbundle 465#CAT mkbundle
436MKBUNDLE 466MKBUNDLE
437} 467}
438 468
439bundle() { 469bundle() {
470 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
440 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 471 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
441 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 472 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
442 CACHE="$STATICPERL/cache" 473 CACHE="$STATICPERL/cache"
443 mkdir -p "$CACHE" 474 mkdir -p "$CACHE"
444 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 475 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
452 command="${1#--}"; shift 483 command="${1#--}"; shift
453 case "$command" in 484 case "$command" in
454 version ) 485 version )
455 echo "staticperl version $VERSION" 486 echo "staticperl version $VERSION"
456 ;; 487 ;;
457 fetch | configure | build | install | clean | distclean) 488 fetch | configure | build | install | clean | realclean | distclean)
458 ( "$command" ) || exit 489 ( "$command" ) || exit
459 ;; 490 ;;
460 instsrc ) 491 instsrc )
461 ( instsrc "$@" ) || exit 492 ( instsrc "$@" ) || exit
462 exit 493 exit
463 ;; 494 ;;
464 instcpan ) 495 instcpan )
465 ( instcpan "$@" ) || exit 496 ( instcpan "$@" ) || exit
466 exit 497 exit
467 ;; 498 ;;
499 perl )
500 ( install ) || exit
501 exec "$PERL_PREFIX/bin/perl" "$@"
502 exit
503 ;;
468 cpan ) 504 cpan )
469 ( install ) || exit 505 ( install ) || exit
470 "$PERL_PREFIX/bin/cpan" "$@" 506 exec "$PERL_PREFIX/bin/cpan" "$@"
471 exit 507 exit
472 ;; 508 ;;
473 mkbundle ) 509 mkbundle )
474 ( install ) || exit 510 ( install ) || exit
475 bundle "$@" 511 bundle "$@"

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines